#include <unistd.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <ctype.h>
#include <string.h>
#include "monopoly.h"

GtkWidget *xpm_label_box (GtkWidget * parent, gchar * xpm_filename, int i, gchar * label_text);

void dogui_shakeoutofjail ()
{
  int i;

#ifdef DEBUG
  printf ("SHAKING OUT OF JAIL\n");
#endif
  threw_double = 0;
  i = shake ();
  InJail[MyPlayerNum]++;
#ifdef DEBUG
  printf ("InJail[%d]=%d\n", MyPlayerNum, InJail[MyPlayerNum]);
#endif
  if (threw_double > 0) {
    InJail[MyPlayerNum] = 0;
    send_structured_packet (JAIL, MyPlayerNum, InJail[MyPlayerNum], "");
    sprintf (note, "Shook yourself out of jail!\n");
    gui_show_text ("Out of jail", note, strlen (note), 200, 70);
  }
}

void dogui_buyoutofjail ()
{
#ifdef DEBUG
  printf ("BUYING OUT OF JAIL\n");
#endif
  Cash[MyPlayerNum] -= 50;
  InJail[MyPlayerNum] = 0;
  sprintf (note, "Bought yourself out of jail\n");
  gui_show_text ("Out of jail", note, strlen (note), 200, 70);
  send_structured_packet (JAIL, MyPlayerNum, InJail[MyPlayerNum], "");
  send_structured_packet (CASH, MyPlayerNum, Cash[MyPlayerNum], "");
}

void dogui_cardoutofjail ()
{
#ifdef DEBUG
  printf ("CARDING OUT OF JAIL\n");
#endif
  OutOfJailFree[MyPlayerNum]--;
  InJail[MyPlayerNum] = 0;
  sprintf (note, "Carded yourself out of jail\n");
  gui_show_text ("Out of jail", note, strlen (note), 200, 70);
  send_structured_packet (JAIL, MyPlayerNum, InJail[MyPlayerNum], "");
  send_structured_packet (CASH, MyPlayerNum, Cash[MyPlayerNum], "");
}
void gui_outofjail (int p)
{
  GtkWidget *mydialog;
  GtkWidget *buyout;
  GtkWidget *shakeout;
  GtkWidget *cardout;
  GtkWidget *playermessage;
  GMainLoop *loop;
  char msg[255];


  /* InJail[] array can count how many turns we've spent in jail.
   * Just make sure that checking InJail[] checks for ">=1" not "==1" */

#ifdef DEBUG
  printf ("In gui_outofjail for %d (%d)\n", p, InJail[p]);
#endif

  if (InJail[p] > 3) {
    sprintf (note, "Out of jail automatically after three turns\n");
    gui_show_text ("Out of jail", note, strlen (note), 200, 70);
    InJail[p] = 0;
    send_structured_packet (JAIL, p, InJail[p], "");
    return;
  }

  loop = g_main_new (FALSE);
  mydialog = gtk_dialog_new ();

  sprintf (msg, "%s is in Jail. (Turn No. %d). You have the following options:", Names[p], InJail[p]);
  //playermessage=gtk_label_new(Names[p]);
  playermessage = gtk_label_new (msg);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->vbox), playermessage, FALSE, TRUE, 0);
  gtk_widget_show (playermessage);
  gtk_window_set_position (GTK_WINDOW (mydialog), GTK_WIN_POS_CENTER);

  if (Cash[p] >= 50) {
    buyout = gtk_button_new_with_label ("Buy Out");
    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->vbox), buyout, FALSE, TRUE, 0);
    gtk_signal_connect (GTK_OBJECT (buyout), "clicked", GTK_SIGNAL_FUNC (dogui_buyoutofjail), NULL);
    gtk_signal_connect_object (GTK_OBJECT (buyout), "clicked", GTK_SIGNAL_FUNC (g_main_quit), GTK_OBJECT (loop));
    gtk_widget_show (buyout);
  }

  if (OutOfJailFree[p] > 0) {
    cardout = gtk_button_new_with_label ("Card Out");
    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->vbox), cardout, FALSE, TRUE, 0);
    gtk_signal_connect (GTK_OBJECT (cardout), "clicked", GTK_SIGNAL_FUNC (dogui_cardoutofjail), NULL);
    gtk_signal_connect_object (GTK_OBJECT (cardout), "clicked", GTK_SIGNAL_FUNC (g_main_quit), GTK_OBJECT (loop));
    gtk_widget_show (cardout);
  }

  shakeout = gtk_button_new_with_label ("Shake Out");
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->vbox), shakeout, FALSE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (shakeout), "clicked", GTK_SIGNAL_FUNC (dogui_shakeoutofjail), NULL);
  gtk_signal_connect_object (GTK_OBJECT (shakeout), "clicked", GTK_SIGNAL_FUNC (g_main_quit), GTK_OBJECT (loop));
  gtk_widget_show (shakeout);

  gtk_widget_show (mydialog);
  g_main_run (loop);
  g_main_destroy (loop);
  gtk_widget_destroy (mydialog);
#ifdef DEBUG
  printf ("Done jail dialog\n");
#endif

}

int gui_chat (int *p, char *msg)
{
  // return 1 for success (like sscanf)
  ;

  return 1;
}

void gui_show_dice (int die0, int die1)
{
  char pixpath[50];
  GtkStyle *style;
  GdkBitmap *mask;
  GdkPixmap *dicepixmaps[2];
  int i;
  int dice[2];
  dice[0] = die0;
  dice[1] = die1;

  style = gtk_widget_get_style (window);
  for (i = 0; i <= 1; i++) {
    gtk_container_remove (GTK_CONTAINER (diceboxes[i]), dicewidgets[i]);
    sprintf (pixpath, "pixmaps/dice%d.xpm", dice[i]);
    dicepixmaps[i] = gdk_pixmap_create_from_xpm (window->window, &mask, &style->bg[GTK_STATE_NORMAL], pixpath);
    dicewidgets[i] = gtk_pixmap_new (dicepixmaps[i], mask);
    gtk_widget_show (dicewidgets[i]);
    gtk_container_add (GTK_CONTAINER (diceboxes[i]), dicewidgets[i]);
  }
}


void do_interact (GtkWidget * widget, char *i)
{
  if (!strcmp (i, "Shake"))
    process_interact ("shake");
  if (!strcmp (i, "Cash"))
    process_interact ("cash");
  if (!strcmp (i, "Parking"))
    process_interact ("parking");
  if (!strcmp (i, "Quit"))
    process_interact ("quit");
  if (!strcmp (i, "Free"))
    process_interact ("free");
  if (!strcmp (i, "House"))
    process_interact ("house");
  if (!strcmp (i, "Mortgage"))
    process_interact ("mortgage");
  if (!strcmp (i, "Own"))
    process_interact ("own");
  if (!strcmp (i, "Sets"))
    process_interact ("sets");
  if (!strcmp (i, "Chat"))
    process_interact ("chat");
  if (!strcmp (i, "Taken"))
    process_interact ("taken");
  if (!strcmp (i, "Jail"))
    process_interact ("jail");
  if (!strcmp (i, "Help"))
    process_interact ("help");
}

void gui_show_houses (int loc)
{
  char pixpath[50];
  struct stat statbuf;

#ifdef DEBUG
  printf ("Calling container_remove...\n");
  printf ("loc=%d.\n", loc);
#endif
  gtk_container_remove (GTK_CONTAINER (button[loc]), box[loc]);
#ifdef DEBUG
  printf ("Done container_remove...\n");
#endif
  if (Board[loc].NoOfHouses > 0)
    sprintf (pixpath, "pixmaps/group%dh%d.xpm", Board[loc].Colour, Board[loc].NoOfHouses);
  else
    sprintf (pixpath, "pixmaps/group%d.xpm", Board[loc].Colour);
#ifdef DEBUG
  printf ("hello: pixpath=%s\n", pixpath);
#endif
  if (stat (pixpath, &statbuf) == -1) {
    sprintf (pixpath, "pixmaps/square%d.xpm", loc);
    if (stat (pixpath, &statbuf) == -1) {
      printf ("Cannot open a pixmap for square %d (Group %d)\n", loc, Board[loc].Colour);
    }
  }
  box[loc] = xpm_label_box (window, pixpath, loc, Board[loc].Name);
  gtk_container_add (GTK_CONTAINER (button[loc]), box[loc]);
  gtk_widget_show (button[loc]);
  gtk_widget_show (box[loc]);
}

void gui_show_owns_street (int location, int player)
{
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;
  char xpm_filename[50];
  int x, y;

#ifdef DEBUG
  printf ("%s now owns %s\n", Names[player], Board[location].Name);
#endif

  if (((location < 20) && (location > 10)) || (location > 30)) {
    sprintf (xpm_filename, "pixmaps/p%dvert.xpm", player);
    if (Board[location].Mortgaged == 1)
      sprintf (xpm_filename, "pixmaps/mortgagedvert.xpm");
  }
  else {
    sprintf (xpm_filename, "pixmaps/p%dhoriz.xpm", player);
    if (Board[location].Mortgaged == 1)
      sprintf (xpm_filename, "pixmaps/mortgagedhoriz.xpm");
  }
  /* Get the style of the button to get the background color. */
  style = gtk_widget_get_style (window);
  /* Now on to the xpm stuff */
  pixmap = gdk_pixmap_create_from_xpm (window->window, &mask, &style->bg[GTK_STATE_NORMAL], xpm_filename);
  pixmapwid = gtk_pixmap_new (pixmap, mask);
  x = xloc (location);
  y = yloc (location);
  if (location < 10) {
    y -= 05;
    x += 2;
  }
  else if (location < 20) {
    x += 85;
    y += 2;
  }
  else if (location < 30) {
    y += 85;
    x += 2;
  }
  else {
    x -= 05;
    y += 2;
  }
  gtk_fixed_put (GTK_FIXED (fixed), pixmapwid, x, y);
  gtk_widget_show (pixmapwid);
}

gint kill_interact_dialog (GtkWidget * widget, GMainLoop * loop)
{
#ifdef DEBUG
  printf ("Killing Dialog...\n");
#endif
  g_main_quit (loop);
  return (FALSE);
}


void add_interact_dialog ()
{
  GtkWidget *dialogbutton[12];
  GMainLoop *loop;
  int i;
  char buf[200];
  char *msg[4] = { "Quit", "House", "Shake", "Mortgage" };

  loop = g_main_new (FALSE);

  interact_dialog = gtk_hbox_new (FALSE, 0);
  gtk_fixed_put (GTK_FIXED (fixed), interact_dialog, 100, 250);
  sprintf (buf, "%s - Main Dialog", Names[MyPlayerNum]);
  for (i = 0; i < 4; i++) {
    dialogbutton[i] = gtk_button_new_with_label (msg[i]);
    gtk_box_pack_start (GTK_BOX (interact_dialog), dialogbutton[i], TRUE, TRUE, 0);
    gtk_signal_connect (GTK_OBJECT (dialogbutton[i]), "clicked", GTK_SIGNAL_FUNC (do_interact), msg[i]);
    if (i == 2)
      gtk_signal_connect (GTK_OBJECT (dialogbutton[i]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop);
    gtk_widget_show (dialogbutton[i]);
  }
  gtk_widget_show (interact_dialog);
  g_main_run (loop);
  g_main_destroy (loop);
  gtk_widget_destroy (interact_dialog);
}

void add_generic_dialog ()
{
  GtkWidget *button[12];
  int i;
  char *msg[9] = { "Help", "Chat", "Taken", "Free", "Own", "Parking", "Sets", "Jail" };
  GtkRequisition req;

  req.width = 50;
  req.height = 20;

  interact_dialog = gtk_hbox_new (FALSE, 0);
  gtk_fixed_put (GTK_FIXED (fixed), interact_dialog, 280, 250);
  gtk_widget_show (interact_dialog);
  for (i = 0; i < 8; i++) {
    button[i] = gtk_button_new_with_label (msg[i]);
    gtk_widget_size_request (button[i], &req);
    gtk_signal_connect (GTK_OBJECT (button[i]), "clicked", GTK_SIGNAL_FUNC (do_interact), msg[i]);
    gtk_box_pack_start (GTK_BOX (interact_dialog), button[i], TRUE, TRUE, 0);
    gtk_widget_show (button[i]);
  }
}

char text_getYN (char *msg, char *Y, char *N)
{
  char c, y, n;
  y = Y[0];
  n = N[0];
  c = '#';
  while ((c != y) && (c != n)) {
    printf ("%s: %s / %s (%c/%c): ", msg, Y, N, y, n);
    c = toupper (fgetc (stdin));
    // Skip the \n ...
  }
  fgetc (stdin);
  return (y == c);
}

void do_guiYN (GtkWidget * widget, char *x)
{
#ifdef DEBUG
  printf ("The button you pressed was '%s'.\n", x);
#endif
  strcpy (YN, x);
}

int xloc (int x)
{
  if (x < 10)
    return ((10 - x) * 56) + 40;
  if (x < 21)
    return 10;
  if (x < 30)
    return ((x - 20) * 56) + 40;
  return 600;
}

int yloc (int y)
{
  if (y < 11)
    return 600;
  if (y < 20)
    return ((20 - y) * 56) + 40;
  if (y < 31)
    return 10;
  return ((y - 30) * 56) + 40;
}

void gui_update_cash ()
{
  int i;
  char msg[50];

  for (i = 1; i <= NoOfPlayers; i++) {
    sprintf (msg, "\n%d", Cash[i]);
    gtk_text_insert (GTK_TEXT (cashtxt[i]), fixed_font, NULL, NULL, msg, strlen (msg));
  }
}

void move_pointer (int player, int loc)
{
  char msg[50];
  int x, y, i;

#ifdef DEBUG
  printf ("move_pointer: loc=%d.\n", loc);
  printf ("move_pointer: From %d.\n", Location[player]);
  if (loc == Location[player])
    printf ("*********************\n   Already there!\n***********\n");
#endif
  sprintf (msg, "\n%s: %s", Names[player], Board[loc].Name);
  gtk_text_insert (GTK_TEXT (loctxt[player]), fixed_font, NULL, NULL, msg, strlen (msg));
  // Do this at more sensible times, please!
  gui_update_cash ();

  i = Location[player];
  i = loc;
  if (i == 40)
    i = 0;
  x = xloc (i);
  y = yloc (i);
  if (i < 11) {
    x += 10 * (player - 1);
    y += 90;
  }
  else if (i < 21) {
    x = 0;
    y += 10 * (player - 1);
  }
  else if (i < 31) {
    x += 10 * (player - 1);
    y = 0;
  }
  else {
    x += 90;
    y += 10 * (player - 1);
  }
  gtk_fixed_move (GTK_FIXED (fixed), GTK_WIDGET (pixmapwid[player]), x, y);
}

void gui_getYN (char *msg, char *Y, char *N)
{
  GtkWidget *dialogbutton[2];
  GtkWidget *mydialog;
  GtkWidget *label;
  GMainLoop *loop;
  char buf[50];

  loop = g_main_new (FALSE);
#ifdef DEBUG
  printf ("%d : Msg: %s\n", strlen (msg), msg);
#endif

  mydialog = gtk_dialog_new ();
  sprintf (buf, "Question: %s.", Names[Player]);
  gtk_window_set_title (GTK_WINDOW (mydialog), buf);
  gtk_window_set_position (GTK_WINDOW (mydialog), GTK_WIN_POS_CENTER);
  label = gtk_label_new (msg);
  // label seems to have trouble with the "" symbol.
  gtk_label_set_justify (GTK_LABEL (label), GTK_JUSTIFY_FILL);
  gtk_label_set_line_wrap (GTK_LABEL (label), FALSE);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->vbox), label, FALSE, TRUE, 0);
  gtk_widget_show (label);
  dialogbutton[0] = gtk_button_new_with_label (Y);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->action_area), dialogbutton[0], TRUE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (dialogbutton[0]), "clicked", GTK_SIGNAL_FUNC (do_guiYN), Y);
  gtk_signal_connect (GTK_OBJECT (dialogbutton[0]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop);
  gtk_widget_show (dialogbutton[0]);
  dialogbutton[1] = gtk_button_new_with_label (N);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mydialog)->action_area), dialogbutton[1], TRUE, TRUE, 0);
  gtk_signal_connect (GTK_OBJECT (dialogbutton[1]), "clicked", GTK_SIGNAL_FUNC (do_guiYN), N);
  gtk_signal_connect (GTK_OBJECT (dialogbutton[1]), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop);
  gtk_widget_show (dialogbutton[1]);

#ifdef DEBUG
  printf ("widget_show...\n");
#endif
  gtk_widget_show (mydialog);
  g_main_run (loop);
  g_main_destroy (loop);
  gtk_widget_destroy (mydialog);
#ifdef DEBUG
  printf ("YN is %s \n", YN);
#endif
}



void gui_house_get_value (GtkWidget * widget, GtkSpinButton * spin)
{
  char buf[32];
  int *i;
  int j, proposed, res;

/*	Note that we are cheating a bit here; we are supposed to
*	pass a pointer to some real data in *i; instead, i itself
*	is the data. So i==1, doesn't refer to some data stored
*	at 0x0001, but to Old Kent Road.
*	This just saves some space and some hassle.
*	We've wasted enough of both elsewhere in the code!!!
*/
  i = gtk_object_get_user_data (GTK_OBJECT (widget));
  j = (int) i;			// Give me a "nice" variable!
  strcpy (buf, Board[j].Name);
#ifdef DEBUG
  printf ("Street=%s.\n", buf);
#endif
  sprintf (buf, "%d", gtk_spin_button_get_value_as_int (spin));
#ifdef DEBUG
  printf ("New NoOfHouses=%s.\n", buf);
#endif

  proposed = atoi (buf);
  res = houses_okay (j, proposed);
  if (res == 0) {

    if (Board[j].NoOfHouses > proposed) {
      /* They're selling a house */
      Cash[Player] += Board[j].CostofHouses / 2;
    }
    else {
      /* They're buying a house */
      Cash[Player] -= Board[j].CostofHouses;
    }
    send_structured_packet (CASH, Player, Cash[Player], "");
    gui_update_cash ();
    Board[j].NoOfHouses = proposed;
    send_structured_packet (HOUSE, j, Board[j].NoOfHouses, "");
    gui_show_houses (j);
  }
  else {
#ifdef DEBUG
    printf ("Houses_Okay returned %d.\n", res);
#endif
    gtk_spin_button_set_value (spin, Board[j].NoOfHouses);
  }
}

GtkWidget *house_box (int i, GtkWidget * dialog)
{
  GtkWidget *hbox, *spinner, *label;
  GtkAdjustment *adj;

  hbox = gtk_hbox_new (FALSE, 5);
  label = gtk_label_new (Board[i].Name);
  gtk_box_pack_start (GTK_BOX (hbox), label, FALSE, TRUE, 0);
  adj = (GtkAdjustment *) gtk_adjustment_new (Board[i].NoOfHouses, 0, 5, 1, 1, 5);
  gtk_object_set_user_data (GTK_OBJECT (adj), (int *) i);
  spinner = gtk_spin_button_new (adj, 0, 0);
  gtk_signal_connect (GTK_OBJECT (adj), "value_changed", GTK_SIGNAL_FUNC (gui_house_get_value), spinner);

  gtk_spin_button_set_wrap (GTK_SPIN_BUTTON (spinner), TRUE);
  gtk_spin_button_set_shadow_type (GTK_SPIN_BUTTON (spinner), GTK_SHADOW_OUT);
  gtk_box_pack_start (GTK_BOX (hbox), spinner, FALSE, TRUE, 0);

  gtk_widget_show (label);
  gtk_widget_show (spinner);
  return (hbox);
}

void gui_buy_sell_houses ()
{
  GtkWidget *housedialog, *okbutton;
  GtkWidget *frame;
  GtkWidget *main_vbox, *vbox[MAXPLAYERS + 1];
  GtkWidget *hbox[4];
  GMainLoop *loop;
  int CanBuy[MAXPLAYERS + 1];
  int i, skip;
  int j = 0;

  for (i = 0; i <= 7; i++)
    CanBuy[i] = 0;
  for (i = 0; i < 40; i++) {
    if ((own_set (Player, i) == 0) && (Board[i].Colour >= 9) && (CanBuy[j] == 0) && (skip != Board[i].Colour)) {
      CanBuy[j++] = i;
      skip = Board[i].Colour;
    }
  }
#ifdef DEBUG
  printf ("You own %d valid sets.\n", j);
#endif
  if (j > 0) {
    loop = g_main_new (FALSE);
    housedialog = gtk_dialog_new ();
    gtk_window_set_position (GTK_WINDOW (housedialog), GTK_WIN_POS_CENTER);
    main_vbox = gtk_vbox_new (FALSE, 5);
    gtk_box_pack_start (GTK_BOX (GTK_DIALOG (housedialog)->action_area), main_vbox, TRUE, TRUE, 0);
#ifdef DEBUG
    printf ("Not Calling gtk_container_add...\n");
    printf ("Calling set_title...\n");
#endif
    gtk_window_set_title (GTK_WINDOW (housedialog), "Buy / Sell Houses");
    for (i = 0; i <= 7; i++) {
      if (CanBuy[i] > 0) {
	char colname[50];
	sprintf (colname, "%s: Cost of Houses=%d", colour_name (Board[CanBuy[i]].Colour), Board[CanBuy[i]].CostofHouses);
#ifdef DEBUG
	printf ("Setting frame...%s\n", colname);
#endif
	frame = gtk_frame_new (colname);
	gtk_box_pack_start (GTK_BOX (main_vbox), frame, TRUE, TRUE, 0);
	vbox[i] = gtk_vbox_new (FALSE, 5);
	gtk_container_add (GTK_CONTAINER (frame), vbox[i]);
	hbox[0] = house_box (CanBuy[i], vbox[i]);
	gtk_container_add (GTK_CONTAINER (vbox[i]), hbox[0]);
	gtk_widget_show (hbox[0]);
	if (Board[CanBuy[i]].OneOtherInSet != 0) {
	  hbox[1] = house_box (Board[CanBuy[i]].OneOtherInSet, vbox[i]);
	  gtk_container_add (GTK_CONTAINER (vbox[i]), hbox[1]);
	  gtk_widget_show (hbox[1]);
	}
	if (Board[CanBuy[i]].TwoOtherInSet != 0) {
	  hbox[2] = house_box (Board[CanBuy[i]].TwoOtherInSet, vbox[i]);
	  gtk_widget_show (hbox[2]);
	  gtk_container_add (GTK_CONTAINER (vbox[i]), hbox[2]);
	}
	if (Board[CanBuy[i]].ThirdOtherInSet != 0) {
	  hbox[3] = house_box (Board[CanBuy[i]].ThirdOtherInSet, vbox[i]);
	  gtk_widget_show (hbox[3]);
	  gtk_container_add (GTK_CONTAINER (vbox[i]), hbox[3]);
	}
	// Add buttons, etc for this, too.
	gtk_widget_show (frame);
	gtk_widget_show (vbox[i]);
      }
      gtk_widget_show (main_vbox);
    }
    okbutton = gtk_button_new_with_label ("Close");
    gtk_signal_connect (GTK_OBJECT (okbutton), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop);
    gtk_box_pack_start (GTK_BOX (main_vbox), okbutton, FALSE, FALSE, 0);
    gtk_widget_show (okbutton);
    gtk_widget_show (housedialog);
    g_main_run (loop);
    g_main_destroy (loop);
    gtk_widget_destroy (housedialog);
  }				// j>0
  else {
    gui_show_text ("Houses", "You don't own any full sets", strlen ("You don't own any full sets"), 200, 70);
  }
}


char getYN (char *msg, char *Y, char *N)
{
  char res;
  if (text)
    res = text_getYN (msg, Y, N);
  else {
    gui_getYN (msg, Y, N);
    res = (!strcmp (YN, Y));
  }
  return res;
}

int getnum (char *msg)
{
  char s[5];
  int res = 0;
  int fail = 0;
  while (res == 0) {
    if (fail == 1)
      fgetc (stdin);
    printf ("%s ", msg);
    fgets (s, 4, stdin);
    res = isdigit ((int) s[0]);
    fail = 1;
  }
  res = atoi (s);
  return res;
}

void gui_show_text (char *titlebar, char *buf, int len, int x, int y)
{
  GtkWidget *mywin;
  GtkWidget *button;
  GtkWidget *vbox;
  GtkWidget *mytext;

  GMainLoop *loop;

#ifdef DEBUG
  printf ("Starting gui_text_show : %s\n", buf);
#endif
  loop = g_main_new (FALSE);

  mywin = gtk_window_new (FALSE);
  gtk_widget_set_usize (mywin, x, y);
  gtk_window_set_position (GTK_WINDOW (mywin), GTK_WIN_POS_CENTER);
  gtk_window_set_title (GTK_WINDOW (mywin), titlebar);
  button = gtk_button_new_with_label ("Dismiss");
  mytext = gtk_text_new (NULL, NULL);
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (mywin), vbox);
  gtk_widget_show (vbox);
  gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, len);
  gtk_text_set_word_wrap (GTK_TEXT (mytext), TRUE);

  gtk_box_pack_start (GTK_BOX (vbox), mytext, TRUE, TRUE, 0);
  gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
#ifdef DEBUG
  printf ("Doing connect_object\n");
#endif
  // Casting loop as GTK_OBJECT causes the message:
  // Gtk-WARNING **: invalid unclassed pointer in cast to `GtkObject'
  gtk_signal_connect_object (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (g_main_quit), GTK_OBJECT (loop));

#ifdef DEBUG
  printf ("Done connect_object\n");
#endif
  gtk_widget_show (mytext);
  gtk_widget_show (button);
  gtk_widget_show (mywin);

  g_main_run (loop);
  g_main_destroy (loop);
  gtk_widget_destroy (mywin);
#ifdef DEBUG
  printf ("Done gui_text_show\n");
#endif
}

void do_mortgage_toggle (GtkWidget * checkbox, int *data)
{
#ifdef DEBUG
  printf ("In do_mortgage_toggle()\n");
  printf ("Data=%p (%d)\n", data, *data);
#endif
  if (GTK_TOGGLE_BUTTON (checkbox)->active) {
    Board[*data].Mortgaged = 1;
#ifdef DEBUG
    printf ("Mortgaged %s\n", Board[*data].Name);
#endif
    Cash[MyPlayerNum] += Board[*data].MortgageValue;
  }
  else {
    int mval;
    mval = (int) Board[*data].MortgageValue * 1.1;
    Board[*data].Mortgaged = 0;
#ifdef DEBUG
    printf ("Unmortgaged %s\n", Board[*data].Name);
#endif
    Cash[MyPlayerNum] -= mval;
  }
  gui_show_owns_street (*data, MyPlayerNum);
  send_structured_packet (CASH, MyPlayerNum, Cash[MyPlayerNum], "");
  send_structured_packet (MORTGAGED, *data, Board[*data].Mortgaged, "");

#ifdef DEBUG
  printf ("Leaving do_mortgage_toggle()\n");
#endif
}

int gui_do_mortgage_group (int ismortgaged, char *titlestr, GtkWidget * main_vbox)
{
  GtkWidget *label[40];
  GtkWidget *orig_cost[40];
  GtkWidget *mort_cost[40];
  GtkWidget *unmort_cost[40];
  GtkWidget *mortgaged[40];
  GtkWidget *title[5];
  GtkWidget *table;
  GtkWidget *frame;
  int i;
  int n = 0;
  int IOwn[40];
  static int iptr[2][40];

  for (i = 0; i < 40; i++) {
    if ((Owns[i] == Player) && (Board[i].Mortgaged == ismortgaged)) {
      if (ismortgaged == 0) {
	if (Board[i].NoOfHouses == 0) {
	  IOwn[n++] = i;
	}
	else {
	  sprintf (note, "Skipping %s as it has houses on it\n", Board[i].Name);
	  notify (note);
	}
      }
      else {
	IOwn[n++] = i;
      }
    }
  }
  if (n == 0) {
    sprintf (note, "You don't own any %s streets\n", titlestr);
    return 0;
  }
  frame = gtk_frame_new (titlestr);
  table = gtk_table_new (n, 5, FALSE);
  gtk_box_pack_start (GTK_BOX (main_vbox), frame, TRUE, TRUE, 0);
  gtk_container_add (GTK_CONTAINER (frame), table);
  gtk_widget_show (frame);

  // Make the "Name" title big, so the two tables match in size
  title[0] = gtk_label_new ("           Name           ");
  title[1] = gtk_label_new (" Face\nValue ");
  title[2] = gtk_label_new (" Mortgage\nValue ");
  title[3] = gtk_label_new (" Redeem\nCost ");
  title[4] = gtk_label_new (" Mortgaged? ");
  gtk_table_attach (GTK_TABLE (table), title[0], 0, 1, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_show (title[0]);
  gtk_table_attach (GTK_TABLE (table), title[1], 1, 2, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_show (title[1]);
  gtk_table_attach (GTK_TABLE (table), title[2], 2, 3, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_show (title[2]);
  gtk_table_attach (GTK_TABLE (table), title[3], 3, 4, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_show (title[3]);
  gtk_table_attach (GTK_TABLE (table), title[4], 4, 5, 0, 1, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (GTK_FILL), 0, 0);
  gtk_widget_show (title[4]);

  for (i = 0; i < n; i++) {
    int mort;
    iptr[ismortgaged][i] = IOwn[i];

    label[i] = gtk_label_new (Board[IOwn[i]].Name);
    gtk_table_attach (GTK_TABLE (table), label[i], 0, 1, i + 1, i + 2, (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (GTK_FILL), 0, 0);
    gtk_widget_show (label[i]);
    sprintf (note, "%d", Board[IOwn[i]].Cost);
    orig_cost[i] = gtk_label_new (note);
    gtk_table_attach (GTK_TABLE (table), orig_cost[i], 1, 2, i + 1, i + 2, (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (GTK_FILL), 0, 0);
    gtk_widget_show (orig_cost[i]);
    sprintf (note, "%d", Board[IOwn[i]].MortgageValue);
    mort_cost[i] = gtk_label_new (note);
    gtk_table_attach (GTK_TABLE (table), mort_cost[i], 2, 3, i + 1, i + 2, (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (GTK_FILL), 0, 0);
    gtk_widget_show (mort_cost[i]);
    mort = (int) Board[IOwn[i]].MortgageValue * 1.1;
    sprintf (note, "%d", mort);
    unmort_cost[i] = gtk_label_new (note);
    gtk_table_attach (GTK_TABLE (table), unmort_cost[i], 3, 4, i + 1, i + 2, (GtkAttachOptions) (GTK_FILL),
		      (GtkAttachOptions) (GTK_FILL), 0, 0);
    gtk_widget_show (unmort_cost[i]);
    mortgaged[i] = gtk_check_button_new ();
#ifdef DEBUG
    printf ("Doing button_set_active\n");
#endif
    gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (mortgaged[i]), (ismortgaged == 1));
#ifdef DEBUG
    printf ("Doing connect_object for mortgaged[%d] button\n", i);
#endif
    gtk_signal_connect (GTK_OBJECT (mortgaged[i]), "clicked", GTK_SIGNAL_FUNC (do_mortgage_toggle), &iptr[ismortgaged][i]);
#ifdef DEBUG
    printf ("Done connect_object\n");
    printf ("Done connect_object for %d\n", iptr[ismortgaged][i]);
#endif

    gtk_table_attach (GTK_TABLE (table), mortgaged[i], 4, 5, i + 1, i + 2, (GtkAttachOptions) (GTK_FILL), (GtkAttachOptions) (0),
		      0, 0);
    gtk_widget_show (mortgaged[i]);
  }
  gtk_widget_show (table);
  return n;
}

void gui_buy_sell_mortgage (int Player)
{

  GtkWidget *okbutton;
  GtkWidget *main_vbox;
  GtkWidget *mortgagedialog;
  GMainLoop *loop;

  int i;

  loop = g_main_new (FALSE);
  mortgagedialog = gtk_dialog_new ();
  main_vbox = gtk_vbox_new (FALSE, 5);
  gtk_window_set_title (GTK_WINDOW (mortgagedialog), "Mortgaging");
  gtk_window_set_position (GTK_WINDOW (mortgagedialog), GTK_WIN_POS_CENTER);
  gtk_box_pack_start (GTK_BOX (GTK_DIALOG (mortgagedialog)->action_area), main_vbox, TRUE, TRUE, 0);

  i = gui_do_mortgage_group (0, "Unmortgaged", main_vbox);
  i += gui_do_mortgage_group (1, "Mortgaged", main_vbox);

  if (i == 0) {
    sprintf (note, "You don't own any streets\n");
    gui_show_text ("No Streets!", note, strlen (note), 200, 70);
    g_main_destroy (loop);
    gtk_widget_destroy (mortgagedialog);
    return;
  }

  okbutton = gtk_button_new_with_label ("Close");
  gtk_signal_connect (GTK_OBJECT (okbutton), "clicked", GTK_SIGNAL_FUNC (kill_interact_dialog), loop);
  gtk_box_pack_start (GTK_BOX (main_vbox), okbutton, FALSE, FALSE, 0);
  gtk_widget_show (main_vbox);
  gtk_widget_show (okbutton);
  gtk_widget_show (mortgagedialog);
  g_main_run (loop);
  g_main_destroy (loop);
  gtk_widget_destroy (mortgagedialog);


}

int audit (int player)
{
  int fingers = 0;		// used for calculations
  int i, j;

  if (Cash[player] > 0)
    fingers = Cash[player];
  fingers += OutOfJailFree[player] * 50;
  for (i = 0; i < 40; i++) {
    if ((Owns[i] == player) && (Board[i].Mortgaged == 0)) {
      for (j = Board[i].NoOfHouses; j > 0; j--)
	fingers += Board[i].CostofHouses / 2;
    }
  }

  for (i = 0; i < 40; i++) {
    if (Owns[i] == player) {
      if (Board[i].Mortgaged == 0) {
	fingers += Board[i].Cost;
      }
      else {
	fingers += Board[i].MortgageValue;
      }
    }
  }				//for

  return fingers;
}

int receive_structured_packet ()
{
  /* For some reason calling a modular gui_show_text in this function causes
   * the dialog to never close. */
  int res;
  int p;
  structured_packet *sp;

  sp = (structured_packet *) malloc (sizeof (structured_packet));
  res = 0;
  if (MyPlayerNum == Master)
    p = Player;
  else
    p = Master;

  receive_packet (sp, sizeof (structured_packet), p);
#ifdef DEBUG
  printf ("recieved packet: %d[%d]=%d (%s)\n", sp->pkttype, sp->index, sp->val, sp->sval);
#endif
  if (MyPlayerNum == Master) {
    /* We must now forward this to all but the one we got it from... */
    send_structured_packet (sp->pkttype, sp->index, sp->val, sp->sval);
  }
  switch (sp->pkttype) {
  case PLAYER:
    Player = sp->val;
    res = sp->val;
    if ((MyPlayerNum == Master) && (text == 0)) {
      gtk_input_remove (interrupt);
      interrupt = add_input (Player);
    }
    break;
    //case BOARD: Board[sp->index]=sp->val; break; /* Can we use this?! */
  case CASH:
    Cash[(int) sp->index] = sp->val;
#ifdef DEBUG
    printf ("Cash[%d]=%d.\n", sp->index, sp->val);
#endif
    if (text == 0)
      gui_update_cash ();
    else {
      sprintf (note, "%s now has %d\n", Names[(int) sp->index], sp->val);
      notify (note);
    }
    break;
  case HOUSE:
    Board[(int) sp->index].NoOfHouses = sp->val;
    sprintf (note, "Board[%d].NoOfHouses=%d.\n", sp->index, sp->val);
    notify (note);
    if (text == 0)
      gui_show_houses (sp->index);
    break;
  case OWNS:
    Owns[(int) sp->index] = sp->val;
    sprintf (note, "%s now owns %s.\n", Names[sp->val], Board[(int) sp->index].Name);
    notify (note);
    if (text == 0)
      gui_show_owns_street (sp->index, sp->val);
    break;
  case FREEPARKING:
    FreeParking = sp->val;
    sprintf (note, "Free Parking now worth %d.\n", sp->val);
    notify (note);
    break;
  case JAIL:
    InJail[(int) sp->index] = sp->val;
    sprintf (note, "InJail[%d]=%d.\n", sp->index, sp->val);
    notify (note);
    //gui_show_text ("Player in Jail", note, strlen (note), 200, 70);
    break;
  case LOCATION:
    move_player (sp->index, sp->val);
    sprintf (note, "%s is on %s.\n", Names[(int) sp->index], Board[sp->val].Name);
    notify (note);
    break;
  case MORTGAGED:
    Board[(int) sp->index].Mortgaged = sp->val;
    sprintf (note, "Square %d Mortgaged=%d.\n", sp->index, sp->val);
    notify (note);
    if (text == 0)
      gui_show_owns_street (sp->index, Player);
    break;
  case QUIT:
    Quit[(int) sp->index] = 1;
    printf ("%s Quit.\n", Names[(int) sp->index]);
    break;
  case CHAT:
    sprintf (note, "%s says '%s' to %s.\n", Names[(int) sp->index], sp->sval, Names[sp->val]);
    notify (note);
    break;
  case TEST:
    printf ("Received test...\n");
    printf ("pkttype=%d, index=%d, val=%d, sval=%s\n", sp->pkttype, sp->index, sp->val, sp->sval);
    break;
  case DICE:
    if (text == 0)
      gui_show_dice (sp->index, sp->val);
    break;
  case INFO:
    sprintf (note, "%s: Information", Names[Player]);
    notify (sp->sval);
    //gui_show_text(note, sp->sval, strlen(sp->sval), 300, 200);
    break;
  default:
#ifdef DEBUG
    printf ("ERROR: Received malformed structured packet...\n");
    printf ("pkttype=%d, index=%d, val=%d, sval=%s\n", sp->pkttype, sp->index, sp->val, sp->sval);
#endif
    sprintf (note, "WARNING: Received malformed structured packet...\n");
    notify (note);
    break;
  }

  if ((sp->pkttype == PLAYER) && (res == MyPlayerNum) && (text == 0))
    play_game ();
  free (sp);
  return res;
}

int add_input (int p)
{
  return gdk_input_add (mysocket[p], GDK_INPUT_READ, GTK_SIGNAL_FUNC (receive_structured_packet), 0);
}

void text_show_street (int loc)
{
  Square s;

  s = Board[loc];

  if (s.Colour > 7) {
    printf (" %-22s", s.Name);
    printf (" Set: %s.\n Owned by ", colour_name (s.Colour));
    if (Owns[loc] == 0)
      printf ("nobody.\n");
    else
      printf ("%s.\n", Names[Owns[loc]]);
    printf ("RENT - SITE ONLY         %5d\n", s.Rent[0]);
    printf (" \"   - with 1 house      %5d\n", s.Rent[1]);
    printf (" \"   - with 2 houses     %5d\n", s.Rent[2]);
    printf (" \"   - with 3 houses     %5d\n", s.Rent[3]);
    printf (" \"   - with 4 houses     %5d\n", s.Rent[4]);
    printf ("RENT WITH HOTEL          %5d\n", s.Rent[5]);
    printf ("\nIf a player owns all the sites of any\n");
    printf (" colour group, the rent is doubled on\n");
    printf ("  unimproved sites in that group.\n\n");
    printf ("Cost of houses           %5d\n", s.CostofHouses);
    printf ("Cost of hotels           %5d plus\n", s.CostofHouses);
    printf ("                            4 houses\n");
    printf ("Mortgage value of site   %5d\n", s.MortgageValue);
    printf ("Face value of site       %5d\n", s.Cost);
    printf ("\nNumber of houses currently on the street: %d.\n", s.NoOfHouses);
  }
  else
    printf ("%s\n", s.Name);
}

void gui_show_street (int loc)
{
  GtkWidget *button;
  GtkWidget *mytext;
  GtkWidget *mywin;
  GtkWidget *vbox;
  char buf[200];
  Square s;

  s = Board[loc];

  if (s.Colour > 7) {
    mywin = gtk_window_new (FALSE);
    gtk_widget_set_usize (mywin, 500, 400);
    gtk_window_set_title (GTK_WINDOW (mywin), s.Name);
    button = gtk_button_new_with_label ("Dismiss");
    mytext = gtk_text_new (NULL, NULL);
    vbox = gtk_vbox_new (FALSE, 0);
    gtk_container_add (GTK_CONTAINER (mywin), vbox);
    gtk_widget_show (vbox);


    sprintf (buf, "Set: %s.\n Owned by ", colour_name (s.Colour));
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    if (Owns[loc] == 0)
      sprintf (buf, "nobody.\n");
    else
      sprintf (buf, "%s.\n", Names[Owns[loc]]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "RENT - SITE ONLY         %5d\n", s.Rent[0]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " \"   - with 1 house      %5d\n", s.Rent[1]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " \"   - with 2 houses     %5d\n", s.Rent[2]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " \"   - with 3 houses     %5d\n", s.Rent[3]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " \"   - with 4 houses     %5d\n", s.Rent[4]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "RENT WITH HOTEL          %5d\n", s.Rent[5]);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "\nIf a player owns all the sites of any\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " colour group, the rent is doubled on\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "  unimproved sites in that group.\n\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "Cost of houses           %5d\n", s.CostofHouses);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "Cost of hotels           %5d plus\n", s.CostofHouses);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "                            4 houses\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "Mortgage value of site   %5d\n", s.MortgageValue);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "Face value of site       %5d\n", s.Cost);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "\nNumber of houses currently on the street: %d.\n", s.NoOfHouses);
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));



    gtk_box_pack_start (GTK_BOX (vbox), mytext, TRUE, TRUE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
    gtk_signal_connect_object (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (mywin));
    gtk_widget_show (mytext);
    gtk_widget_show (button);
    gtk_widget_show (mywin);
  }
}

int text_what_do_i_own (int player, int verbose)
{
  int i, j = 0;

  if (verbose == 1) {
    printf ("                                                  Mortgage  No of\n");
    printf (" p   Street Name               Colour        Cost    Value    Houses  Rent\n");
    printf ("    ------------------   --------------------------------------------------\n");
  }

  for (i = 0; i < 40; i++)
    if (Owns[i] == player || ((player == -1) && Owns[i] > 0)) {
      if ((verbose == 1) && (Board[i].Colour >= 7)) {
	printf ("%2d   %-25s %-12s  %4d  %4d       %d     %4d\n", Owns[i],
		Board[i].Name, colour_name (Board[i].Colour), Board[i].Cost,
		Board[i].MortgageValue, Board[i].NoOfHouses, get_rent (i));
      }
      j++;
    }
  return j;
}

int gui_what_do_i_own (int player, int verbose)
{
  GtkWidget *mywin;
  int i, j = 0;
  GtkWidget *button;
  GtkWidget *mytext;
  GtkWidget *vbox;
  char buf[200];
  Square s;

  s = Board[Location[player]];

  sprintf (buf, "Streets Owned by %s", Names[player]);
  if (player == -1)
    sprintf (buf, "List of All Owned Streets");
  if (player == 0)
    sprintf (buf, "List of All Free Streets");
  mywin = gtk_window_new (FALSE);
  gtk_widget_set_usize (mywin, 800, 500);
  gtk_window_set_title (GTK_WINDOW (mywin), buf);
  button = gtk_button_new_with_label ("Dismiss");
  mytext = gtk_text_new (NULL, NULL);
  vbox = gtk_vbox_new (FALSE, 0);
  gtk_container_add (GTK_CONTAINER (mywin), vbox);
  gtk_widget_show (vbox);


  if (verbose == 1) {
    sprintf (buf, "                                                  Mortgage    No of\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, " p   Street Name               Colour        Cost    Value    Houses  Rent\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
    sprintf (buf, "    ------------------   --------------------------------------------------\n");
    gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
  }

  for (i = 0; i < 40; i++)
    if (Owns[i] == player || ((player == -1) && Owns[i] > 0)) {
      if ((verbose == 1) && (Board[i].Colour >= 7)) {
	sprintf (buf, "%2d   %-25s %-12s  %4d  %4d       %d     %4d\n", Owns[i],
		 Board[i].Name, colour_name (Board[i].Colour), Board[i].Cost,
		 Board[i].MortgageValue, Board[i].NoOfHouses, get_rent (i));
	gtk_text_insert (GTK_TEXT (mytext), fixed_font, NULL, NULL, buf, strlen (buf));
      }
      j++;
    }

  if (verbose == 1) {
    gtk_box_pack_start (GTK_BOX (vbox), mytext, TRUE, TRUE, 0);
    gtk_box_pack_start (GTK_BOX (vbox), button, FALSE, FALSE, 0);
    gtk_signal_connect_object (GTK_OBJECT (button), "clicked", GTK_SIGNAL_FUNC (gtk_widget_destroy), GTK_OBJECT (mywin));
    gtk_widget_show (mytext);
    gtk_widget_show (button);
    gtk_widget_show (mywin);
  }
  return j;
}

gint delete_event (GtkWidget * widget, GdkEvent * event, gpointer data)
{
  return (TRUE);
}

void destroy (GtkWidget * widget, gpointer data)
{
  gtk_main_quit ();
}

void showinfo (GtkWidget * widget, int *i)
{
  printf ("Your button is %s (%d)\n", Board[*i].Name, *i);
  show_street (*i);
}


GtkWidget *xpm_label_box (GtkWidget * parent, gchar * xpm_filename, int i, gchar * label_text)
{
  GtkWidget *box1;
  GtkWidget *pixmapwid;
  GdkPixmap *pixmap;
  GdkBitmap *mask;
  GtkStyle *style;

  /* Create box for xpm and label */
  if ((i < 11) || ((i >= 20) && (i <= 30)))
    box1 = gtk_vbox_new (FALSE, 0);
  else
    box1 = gtk_vbox_new (FALSE, 0);
  gtk_container_set_border_width (GTK_CONTAINER (box1), 0);

  /* Get the style of the button to get the background color. */
  style = gtk_widget_get_style (parent);
  /* Now on to the xpm stuff */
  pixmap = gdk_pixmap_create_from_xpm (parent->window, &mask, &style->bg[GTK_STATE_NORMAL], xpm_filename);
  pixmapwid = gtk_pixmap_new (pixmap, mask);

  /*  Pack the pixmap and label into the box */
  if ((i < 11) || ((i >= 20) && (i <= 30))) {
    gtk_box_pack_start (GTK_BOX (box1), pixmapwid, TRUE, TRUE, 0);
  }
  else {
    gtk_box_pack_start (GTK_BOX (box1), pixmapwid, TRUE, TRUE, 0);
  }
  gtk_widget_show (pixmapwid);

  return (box1);
}


GtkWidget *add_text_box (int x, int y, int xdim, int ydim)
{
  GtkWidget *w;

  w = gtk_text_new (NULL, NULL);
  gtk_fixed_put (GTK_FIXED (fixed), w, x, y);
  gtk_widget_set_usize (w, xdim, ydim);
  gtk_widget_show (w);
  gtk_widget_realize (w);

  return w;
}

void gui_start (int argc, char **argv)
{
  struct stat statbuf;
  GtkTooltips *tooltips;
  char msg[50];
  char pixpath[50];
  char xpm_filename[50];
  GdkPixmap *playerarrow, *dicepixmaps[2];
  GtkWidget *PlayerIcon[NoOfPlayers];
  GtkStyle *style;
  GdkBitmap *mask;
  int i;
  int x, y;
  int j[40];

  gtk_init (&argc, &argv);
  small_font = gdk_font_load ("-*-new century schoolbook-medium-r-normal-*-8-*-*-*-*-*-*-*");
  fixed_font = gdk_font_load ("-misc-fixed-medium-r-*-*-*-140-*-*-*-*-*-*");
  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_widget_set_usize (window, 700, 700);
  gtk_window_set_title (GTK_WINDOW (window), Names[MyPlayerNum]);
  gtk_container_set_border_width (GTK_CONTAINER (window), 0);
  gtk_signal_connect (GTK_OBJECT (window), "destroy", GTK_SIGNAL_FUNC (gtk_main_quit), NULL);
  fixed = gtk_fixed_new ();
  gtk_container_add (GTK_CONTAINER (window), fixed);
  gtk_widget_show (fixed);
  gtk_widget_realize (window);
  tooltips = gtk_tooltips_new ();
  for (i = 0; i < 40; i++) {
    sprintf (msg, "%s", Board[i].Name);
    button[i] = gtk_button_new ();
    sprintf (pixpath, "pixmaps/group%d.xpm", Board[i].Colour);
    if (stat (pixpath, &statbuf) == -1) {
      sprintf (pixpath, "pixmaps/square%d.xpm", i);
      if (stat (pixpath, &statbuf) == -1) {
	printf ("Cannot open a pixmap for square %d (Group %d)\n", i, Board[i].Colour);
      }
    }
    box[i] = xpm_label_box (window, pixpath, i, Board[i].Name);
    gtk_container_add (GTK_CONTAINER (button[i]), box[i]);
    gtk_tooltips_set_tip (tooltips, button[i], msg, NULL);
    j[i] = i;

    x = xloc (i);
    y = yloc (i);
    gtk_signal_connect (GTK_OBJECT (button[i]), "clicked", GTK_SIGNAL_FUNC (showinfo), &j[i]);
    gtk_fixed_put (GTK_FIXED (fixed), button[i], x, y);
    gtk_widget_show (button[i]);
    gtk_widget_show (box[i]);
  }
  add_generic_dialog ();
  for (i = 1; i <= NoOfPlayers; i++) {
    sprintf (xpm_filename, "pixmaps/player%d.xpm", i);
    style = gtk_widget_get_style (window);
#ifdef DEBUG
    printf ("fixed->window=%p.\n", window->window);
#endif
    playerarrow = gdk_pixmap_create_from_xpm (window->window, &mask, &style->bg[GTK_STATE_NORMAL], xpm_filename);
    pixmapwid[i] = gtk_pixmap_new (playerarrow, mask);
    PlayerIcon[i] = gtk_pixmap_new (playerarrow, mask);
    gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (pixmapwid[i]), xloc (0) + 10 * i, yloc (0) + 90);
    gtk_widget_show (GTK_WIDGET (pixmapwid[i]));
    sprintf (msg, "%s", Names[i]);
    gtk_tooltips_set_tip (tooltips, GTK_WIDGET (pixmapwid[i]), msg, NULL);

    // Now put an icon by their name...
    gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (PlayerIcon[i]), 580, 350 + (20 * i));
    gtk_widget_show (GTK_WIDGET (PlayerIcon[i]));
    gtk_widget_realize (GTK_WIDGET (PlayerIcon[i]));
  }

  diceboxes[0] = gtk_hbox_new (FALSE, 0);
  diceboxes[1] = gtk_hbox_new (FALSE, 0);


  dicepixmaps[0] = gdk_pixmap_create_from_xpm (window->window, &mask, &style->bg[GTK_STATE_NORMAL], "pixmaps/dice0.xpm");
  dicepixmaps[1] = gdk_pixmap_create_from_xpm (window->window, &mask, &style->bg[GTK_STATE_NORMAL], "pixmaps/dice0.xpm");
  dicewidgets[0] = gtk_pixmap_new (dicepixmaps[0], mask);
  dicewidgets[1] = gtk_pixmap_new (dicepixmaps[1], mask);
  gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (diceboxes[0]), 500, 100);
  gtk_fixed_put (GTK_FIXED (fixed), GTK_WIDGET (diceboxes[1]), 550, 100);
  gtk_container_add (GTK_CONTAINER (diceboxes[0]), dicewidgets[0]);
  gtk_container_add (GTK_CONTAINER (diceboxes[1]), dicewidgets[1]);
  gtk_widget_show (GTK_WIDGET (dicewidgets[0]));
  gtk_widget_show (GTK_WIDGET (dicewidgets[1]));
  gtk_widget_show (GTK_WIDGET (diceboxes[0]));
  gtk_widget_show (GTK_WIDGET (diceboxes[1]));

  mytext = add_text_box (100, 100, 400, 100);
  for (i = 1; i <= NoOfPlayers; i++) {
    loctxt[i] = add_text_box (100, 350 + (20 * i), 400, 20);
    sprintf (msg, "%s: %s", Names[i], Board[Location[i]].Name);
#ifdef DEBUG
    printf ("MSG: %s\n", msg);
#endif
    gtk_text_insert (GTK_TEXT (loctxt[i]), fixed_font, NULL, NULL, msg, strlen (msg));
#ifdef DEBUG
    printf ("Done gtk_text_insert()\n");
#endif
    cashtxt[i] = add_text_box (500, 350 + (20 * i), 80, 20);
    sprintf (msg, "%d", Cash[i]);
#ifdef DEBUG
    printf ("MSG: %s\n", msg);
#endif
    gtk_text_insert (GTK_TEXT (cashtxt[i]), fixed_font, NULL, NULL, msg, strlen (msg));
#ifdef DEBUG
    printf ("Done gtk_text_insert()\n");
#endif
  }

  gtk_widget_show (window);
  if (MyPlayerNum == Master) {
    interrupt = add_input (i);
    play_game ();
  }
  else
    interrupt = add_input (1);
  gtk_main ();


  return;
}
