// The rules are OR'd together to create one integer (int rules).
// This variable can then be AND'd:
// if (rules & RULE_CANT_BUY_IF_BROKE) printf("You can't afford it") else printf("You can buy it");

// Can't buy property/houses/etc if it would make you bankrupt
#define RULE_CANT_BUY_IF_BROKE 1
// Three doubles means you're in jail
#define RULE_THREE_AND_IN 2
// Does Free Parking take/give cash?
#define RULE_FREE_PARKING 4
// Do you get 400 for landing on GO, or just the normal 200?
#define RULE_400_FOR_GO 8
// Is there an artificial limit on the number of buildings? (32 houses, 12 hotels)
// Note: If there is a limit, the Bank can auction buildings to the highest bidder.
#define RULE_LIMITED_BUILDINGS 16
// Can I only buy/sell houses, mortgage/unmortgage property at the start of my go?
#define RULE_BUY_BEFORE_SHAKE 32
// Is this a time-limited game? (Need another var for the time limit)
#define RULE_TIMELIMIT 64
// Can I collect rent while in jail?
#define RULE_COLLECT_RENT_IN_JAIL 128
// Must I have balanced houses/
#define RULE_BALANCED_HOUSES 256
// Can I buy on first lap?
#define RULE_FIRST_LAP 512
